XCache: A simplest and thread-safe LRU cache, which support key-func, release-func and hit-stat.
===============

Setup
===============
```bash
pip install x-cache
```


Key Features
===============
- LRU cache
- Thread safe
- Support special key function
- Support special release function
- Has detail hit stat


Quick Start
===============

```python
from xcache import xcache, show_xcache_hit_stat


@xcache(3, key_func=lambda x,y: x, log_keys=True)
def calc(x, y):
    print("calc {}, {}".format(x, y))
    return x + y


if __name__ == "__main__":
    print(calc(5, 6))
    print(calc(5, 6))
    print(calc(5, 6))
    print(calc(5, 5))
    print(calc(4, 6))
    print(calc(3, 6))
    print(calc(2, 6))
    print(calc(1, 6))
    print(calc(9, 6))

    print(json.dumps(show_xcache_hit_stat(x), indent=4))  # show detail hit stat
```

Core Function Descriptor: xcache
================

```python
@xcache(cache_size, key_func=None, release_func=None, log_keys=False)
```

| Param Value  | Description                 |
| ------------ | ----------------------------|
| cache_size   | size of cache storage       |
| key_fun      | special key function        |
| release_func | special release function    |
| log_keys     | log keys, for ``DEBUG``     |

